<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOpticalPoP ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOpticalPoP
 * @subpackage Arrays
 */
class ArrayOfOpticalPoP extends AbstractStructArrayBase
{
    /**
     * The OpticalPoP
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OpticalPoP[]
     */
    public $OpticalPoP;
    /**
     * Constructor method for ArrayOfOpticalPoP
     * @uses ArrayOfOpticalPoP::setOpticalPoP()
     * @param \StructType\OpticalPoP[] $opticalPoP
     */
    public function __construct(array $opticalPoP = array())
    {
        $this
            ->setOpticalPoP($opticalPoP);
    }
    /**
     * Get OpticalPoP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OpticalPoP[]|null
     */
    public function getOpticalPoP()
    {
        return isset($this->OpticalPoP) ? $this->OpticalPoP : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOpticalPoP method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOpticalPoP method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOpticalPoPForArrayConstraintsFromSetOpticalPoP(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOpticalPoPOpticalPoPItem) {
            // validation for constraint: itemType
            if (!$arrayOfOpticalPoPOpticalPoPItem instanceof \StructType\OpticalPoP) {
                $invalidValues[] = is_object($arrayOfOpticalPoPOpticalPoPItem) ? get_class($arrayOfOpticalPoPOpticalPoPItem) : sprintf('%s(%s)', gettype($arrayOfOpticalPoPOpticalPoPItem), var_export($arrayOfOpticalPoPOpticalPoPItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OpticalPoP property can only contain items of type \StructType\OpticalPoP, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OpticalPoP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OpticalPoP[] $opticalPoP
     * @return \ArrayType\ArrayOfOpticalPoP
     */
    public function setOpticalPoP(array $opticalPoP = array())
    {
        // validation for constraint: array
        if ('' !== ($opticalPoPArrayErrorMessage = self::validateOpticalPoPForArrayConstraintsFromSetOpticalPoP($opticalPoP))) {
            throw new \InvalidArgumentException($opticalPoPArrayErrorMessage, __LINE__);
        }
        if (is_null($opticalPoP) || (is_array($opticalPoP) && empty($opticalPoP))) {
            unset($this->OpticalPoP);
        } else {
            $this->OpticalPoP = $opticalPoP;
        }
        return $this;
    }
    /**
     * Add item to OpticalPoP value
     * @throws \InvalidArgumentException
     * @param \StructType\OpticalPoP $item
     * @return \ArrayType\ArrayOfOpticalPoP
     */
    public function addToOpticalPoP(\StructType\OpticalPoP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OpticalPoP) {
            throw new \InvalidArgumentException(sprintf('The OpticalPoP property can only contain items of type \StructType\OpticalPoP, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OpticalPoP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OpticalPoP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OpticalPoP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OpticalPoP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OpticalPoP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OpticalPoP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OpticalPoP
     */
    public function getAttributeName()
    {
        return 'OpticalPoP';
    }
}
