<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetNNIAgreements
     * Meta information extracted from the WSDL
     * - documentation: This method accepts a valid username and API Key and returns a list of NNIs for the user’s parent customer. Use the returned NNI ID to populate End A for a Point to NNI Quotation | This method accepts a valid username and API Key
     * and returns a list of NNIs for the user’s parent customer. Use the returned NNI ID to populate End A for a Point to NNI Quotation | This method accepts a valid username and API Key and returns a list of NNIs for the user’s parent customer. Use
     * the returned NNI ID to populate End A for a Point to NNI Quotation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetNNIAgreements $parameters
     * @return \StructType\GetNNIAgreementsResponse|bool
     */
    public function GetNNIAgreements(\StructType\GetNNIAgreements $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetNNIAgreements($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetNNICapablePoPs
     * Meta information extracted from the WSDL
     * - documentation: This method accepts a valid username and API Key and returns a list of NNI capable PoPs. Use the returned PoP ID and required Port to populate End A for a Point to NNI Quotation. This will generate a quote using a new NNI, which will
     * need to be provisioned along with your order. Note that the pricing returned will not include the cost of the new NNI. | This method accepts a valid username and API Key and returns a list of NNI capable PoPs. Use the returned PoP ID and required
     * Port to populate End A for a Point to NNI Quotation. This will generate a quote using a new NNI, which will need to be provisioned along with your order. Note that the pricing returned will not include the cost of the new NNI. | This method accepts a
     * valid username and API Key and returns a list of NNI capable PoPs. Use the returned PoP ID and required Port to populate End A for a Point to NNI Quotation. This will generate a quote using a new NNI, which will need to be provisioned along with your
     * order. Note that the pricing returned will not include the cost of the new NNI.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetNNICapablePoPs $parameters
     * @return \StructType\GetNNICapablePoPsResponse|bool
     */
    public function GetNNICapablePoPs(\StructType\GetNNICapablePoPs $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetNNICapablePoPs($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetEthernetPoPs
     * Meta information extracted from the WSDL
     * - documentation: This method accepts a valid username, API Key and a Customer Site Postcode. It returns a list of Ethernet PoPs. Use the returned PoP ID to populate the A/BEndPoPId. This will generate a quote using that point of presence if possible.
     * This allows you to choose which Data Centre Building you want to connect to, where there are multiple options. | This method accepts a valid username, API Key and a Customer Site Postcode. It returns a list of Ethernet PoPs. Use the returned PoP ID
     * to populate the A/BEndPoPId. This will generate a quote using that point of presence if possible. This allows you to choose which Data Centre Building you want to connect to, where there are multiple options. | This method accepts a valid username,
     * API Key and a Customer Site Postcode. It returns a list of Ethernet PoPs. Use the returned PoP ID to populate the A/BEndPoPId. This will generate a quote using that point of presence if possible. This allows you to choose which Data Centre Building
     * you want to connect to, where there are multiple options.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetEthernetPoPs $parameters
     * @return \StructType\GetEthernetPoPsResponse|bool
     */
    public function GetEthernetPoPs(\StructType\GetEthernetPoPs $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetEthernetPoPs($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetLocationCapabilities
     * Meta information extracted from the WSDL
     * - documentation: This method accepts a valid username, API Key and a Customer Site Postcode. It returns a list of addresses and their associated capabilities. For example, use the returned Address ID to populate A/BEndColtBuildingId, if that location
     * includes the 'Colt Enabled Building' flag, to include Colt as an Access Provider option. | This method accepts a valid username, API Key and a Customer Site Postcode. It returns a list of addresses and their associated capabilities. For example, use
     * the returned Address ID to populate A/BEndColtBuildingId, if that location includes the 'Colt Enabled Building' flag, to include Colt as an Access Provider option. | This method accepts a valid username, API Key and a Customer Site Postcode. It
     * returns a list of addresses and their associated capabilities. For example, use the returned Address ID to populate A/BEndColtBuildingId, if that location includes the 'Colt Enabled Building' flag, to include Colt as an Access Provider option.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetLocationCapabilities $parameters
     * @return \StructType\GetLocationCapabilitiesResponse|bool
     */
    public function GetLocationCapabilities(\StructType\GetLocationCapabilities $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetLocationCapabilities($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetOpticalPoPs
     * Meta information extracted from the WSDL
     * - documentation: This method accepts a valid username, API Key. It returns a list of Optical PoPs. Use the returned PoP ID to populate the A/BEndPoPId for an Optical P2P quote. | This method accepts a valid username, API Key. It returns a list of
     * Optical PoPs. Use the returned PoP ID to populate the A/BEndPoPId for an Optical P2P quote. | This method accepts a valid username, API Key. It returns a list of Optical PoPs. Use the returned PoP ID to populate the A/BEndPoPId for an Optical P2P
     * quote.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GetOpticalPoPs $parameters
     * @return \StructType\GetOpticalPoPsResponse|bool
     */
    public function GetOpticalPoPs(\StructType\GetOpticalPoPs $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetOpticalPoPs($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\GetEthernetPoPsResponse|\StructType\GetLocationCapabilitiesResponse|\StructType\GetNNIAgreementsResponse|\StructType\GetNNICapablePoPsResponse|\StructType\GetOpticalPoPsResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
