<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OpticalPoP StructType
 * @subpackage Structs
 */
class OpticalPoP extends EthernetPoP
{
    /**
     * The IsInfinera
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsInfinera;
    /**
     * The IsPOA
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsPOA;
    /**
     * Constructor method for OpticalPoP
     * @uses OpticalPoP::setIsInfinera()
     * @uses OpticalPoP::setIsPOA()
     * @param bool $isInfinera
     * @param bool $isPOA
     */
    public function __construct($isInfinera = null, $isPOA = null)
    {
        $this
            ->setIsInfinera($isInfinera)
            ->setIsPOA($isPOA);
    }
    /**
     * Get IsInfinera value
     * @return bool
     */
    public function getIsInfinera()
    {
        return $this->IsInfinera;
    }
    /**
     * Set IsInfinera value
     * @param bool $isInfinera
     * @return \StructType\OpticalPoP
     */
    public function setIsInfinera($isInfinera = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInfinera) && !is_bool($isInfinera)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInfinera, true), gettype($isInfinera)), __LINE__);
        }
        $this->IsInfinera = $isInfinera;
        return $this;
    }
    /**
     * Get IsPOA value
     * @return bool
     */
    public function getIsPOA()
    {
        return $this->IsPOA;
    }
    /**
     * Set IsPOA value
     * @param bool $isPOA
     * @return \StructType\OpticalPoP
     */
    public function setIsPOA($isPOA = null)
    {
        // validation for constraint: boolean
        if (!is_null($isPOA) && !is_bool($isPOA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isPOA, true), gettype($isPOA)), __LINE__);
        }
        $this->IsPOA = $isPOA;
        return $this;
    }
}
